hacktivist/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from hacktivist import views
from drf_spectacular.views import (
    SpectacularAPIView,
    SpectacularSwaggerView,
    SpectacularRedocView,
)

# Site Settings
admin.site.site_header = "Hacktivist"
admin.site.site_title = "Hacktivist Portal"
admin.site.index_title = "Welcome to Hacktivist Portal"

urlpatterns = [
    path("admin/", admin.site.urls),
    path("accounts/", include("allauth.urls")),
    path("", views.SignInView.as_view(), name="home"),
    path("logout/", views.signout, name="signout"),
    path("user/", include("member.urls", namespace="member")),
    path("meetups/", include("meetups.urls")),
    path("alternatives/", include("software.urls", namespace="software")),
    path("api/schema/", SpectacularAPIView.as_view(), name="schema"),
    path(
        "api/swagger",
        SpectacularSwaggerView.as_view(url_name="schema"),
        name="swagger-ui",
    ),
    path(
        "api/redoc/",
        SpectacularRedocView.as_view(url_name="schema"),
        name="redoc",
    ),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

member/urls.py
from django.urls import path
from rest_framework.routers import DefaultRouter
from member import views

app_name = "member"

router = DefaultRouter()
router.register("api/signup", views.CreateUserView)
router.urls

urlpatterns = router.urls + [
    path("signup/", views.UserCreationView.as_view(), name="signup"),
]

software/urls.py
from django.urls import path
from software import views

app_name = "alternatives"

urlpatterns = [
    path("", views.index, name="home"),
    path("tags/<slug:slug>/", views.index, name="tag"),
    path("categories/<slug:slug>/", views.index, name="category"),
    path("<slug:slug>/", views.index, name="software"),
]

software/models.py
from django.db import models
from django.utils.translation import gettext_lazy as _
from django.urls import reverse
import uuid


# Create your models here.
class Tag(models.Model):
    id = models.UUIDField(default=uuid.uuid4, primary_key=True)
    name = models.CharField(max_length=50, verbose_name=_("Name"))
    slug = models.SlugField(unique=True, null=False)
    created_at = models.DateTimeField(auto_now_add=True, auto_created=True, null=True)
    updated_at = models.DateTimeField(auto_now=True)

    def get_absolute_url(self):
        return reverse("software:tag", args=[self.slug])

    def __str__(self) -> str:
        return f"{self.name}"

    class Meta:
        ordering = ["name"]
        verbose_name = _("Tag")
        verbose_name_plural = _("Tags")


class Category(models.Model):
    id = models.UUIDField(default=uuid.uuid4, primary_key=True)
    name = models.CharField(max_length=50, verbose_name=_("Name"))
    slug = models.SlugField(unique=True, null=False)
    created_at = models.DateTimeField(auto_now_add=True, auto_created=True, null=True)
    updated_at = models.DateTimeField(auto_now=True)

    def get_absolute_url(self):
        return reverse("software:category", args=[self.slug])

    def __str__(self) -> str:
        return f"{self.name}"

    class Meta:
        ordering = ["name"]
        verbose_name = _("Category")
        verbose_name_plural = _("Categories")


class License(models.Model):
    id = models.UUIDField(default=uuid.uuid4, primary_key=True)
    name = models.CharField(max_length=100, verbose_name=_("Name"))
    url_source = models.URLField(verbose_name=_("License URL"), null=True, blank=True)
    created_at = models.DateTimeField(auto_now_add=True, auto_created=True, null=True)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self) -> str:
        return f"{self.name}"

    class Meta:
        ordering = ["name"]
        verbose_name = _("License")
        verbose_name_plural = _("Licenses")


class Software(models.Model):
    CHOICES_IS_FOSS = (
        (True, "Yes"),
        (False, "No"),
    )

    id = models.UUIDField(default=uuid.uuid4, primary_key=True)
    name = models.CharField(max_length=50, verbose_name=_("Name"))
    slug = models.SlugField(unique=True, null=False, blank=True)
    url_wikipedia = models.URLField(
        verbose_name=_("Wikipedia URL"), unique=True, null=True, blank=True
    )
    page_home = models.URLField(
        verbose_name=_("Homepage"), unique=True, null=True, blank=True
    )
    tags = models.ManyToManyField("software.Tag", verbose_name=_("Tags"))
    category = models.ManyToManyField("software.Category", verbose_name=_("Categories"))
    alternatives = models.ManyToManyField(
        "software.Software",
        verbose_name=_("Alternative Softwares"),
        blank=True,
    )
    is_foss = models.BooleanField(
        choices=CHOICES_IS_FOSS, verbose_name=_("is FOSS"), null=True, blank=True
    )
    license = models.ForeignKey(
        "software.License", on_delete=models.CASCADE, null=True, blank=True
    )
    created_at = models.DateTimeField(auto_now_add=True, auto_created=True, null=True)
    updated_at = models.DateTimeField(auto_now=True)

    def get_absolute_url(self):
        return reverse("software:software", args=[self.slug])

    def __str__(self) -> str:
        return f"{self.name} | {self.is_foss}"

    class Meta:
        ordering = ["-updated_at"]
        verbose_name = _("Software")
        verbose_name_plural = _("Softwares")

software/views.py
from django.shortcuts import render
from software.models import Category

# Create your views here.


def index(request):
    return render(request, "alternatives.html", {"categories": Category.objects.all()})

software/templates/alternatives.html
{% extends "_base.html" %} {% block title %}Alternatives{% endblock%} 
{% block content %}
<div class="flex items-center justify-center py-4 md:py-8 flex-wrap">
  <a
    class="text-blue-700 hover:text-white border border-blue-600 bg-white hover:bg-blue-700 focus:ring-4 focus:outline-none focus:ring-blue-300 rounded-full text-base font-medium px-5 py-2.5 text-center me-3 mb-3 dark:border-blue-500 dark:text-blue-500 dark:hover:text-white dark:hover:bg-blue-500 dark:bg-gray-900 dark:focus:ring-blue-800"
    href="{% url 'alternatives:home' %}"
  >
    All categories
  </a>
  {% for category in categories %}
  <a
    class="text-gray-900 border border-white hover:border-gray-200 dark:border-gray-900 dark:bg-gray-900 dark:hover:border-gray-700 bg-white focus:ring-4 focus:outline-none focus:ring-gray-300 rounded-full text-base font-medium px-5 py-2.5 text-center me-3 mb-3 dark:text-white dark:focus:ring-gray-800"
    href="{{category}}"
  >
    {{category.name}}
  </a>
  {% endfor %}
</div>
<div class="grid grid-cols-2 md:grid-cols-3 lg:grid-cols-4 gap-4 px-5">
    <!--Card 1-->
    <div class="w-full lg:max-w-full flex flex-col lg:flex-row aspect-square">
      <div class="flex flex-auto px-3 lg:px-0 lg:py-3 bg-cover rounded-t lg:rounded-t-none lg:rounded-l text-center justify-center items-center overflow-hidden border-x border-t lg:border-x-0 lg:border-y lg:border-l border-gray-400"
      >
        <div class="bg-red-600 w-2 rounded-full"></div>
        <img 
          src='https://vscodium.com/img/codium_cnl.svg' alt="">
      </div>
      <div
        class="border-r border-b border-l border-gray-400 lg:border-l-0 lg:border-t bg-white rounded-b lg:rounded-b-none lg:rounded-r p-4 flex flex-col justify-between leading-normal"
      >
        <div class="mb-8">
          <p class="text-sm text-gray-600 flex items-center">
            <svg
              class="fill-current text-gray-500 w-3 h-3 mr-2"
              xmlns="http://www.w3.org/2000/svg"
              viewBox="0 0 20 20"
            >
              <path
                d="M4 8V6a6 6 0 1 1 12 0v2h1a2 2 0 0 1 2 2v8a2 2 0 0 1-2 2H3a2 2 0 0 1-2-2v-8c0-1.1.9-2 2-2h1zm5 6.73V17h2v-2.27a2 2 0 1 0-2 0zM7 6v2h6V6a3 3 0 0 0-6 0z"
              />
            </svg>
            Members only
          </p>
          <div class="text-gray-900 font-bold text-xl">
            VSCODIUM
          </div>
        </div>
        <div class="flex items-center">
          <img
            class="w-10 h-10 rounded-full mr-4"
            src=""
            alt="1"
          />
          <div class="text-sm">
            <p class="text-gray-900 leading-none">John Smith</p>
            <p class="text-gray-600">Aug 18</p>
          </div>
        </div>
      </div>
    </div>
</div>
{% endblock %}